//---------------------------------------------------------------------------

#include <vcl.h>
#include <windows.h>
#include "ComObj.hpp"
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
Variant ceClass;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}

//---------------------------------------------------------------------------
void fDeviceArrival()
{
  int devCount = ceClass.OlePropertyGet("numConnectedDevices");
  Form1->Label1->Caption = "Total " + IntToStr(devCount) + " of 4 device(s) attached";
}

//---------------------------------------------------------------------------
void fDeviceRemove()
{
  int devCount = ceClass.OlePropertyGet("numConnectedDevices");
  Form1->Label1->Caption = "Total " + IntToStr(devCount) + " of 4 device(s) attached";
}

//---------------------------------------------------------------------------
void fLineEvent(PAnsiChar DeviceSerial, char Port, PAnsiChar Event)
{
  Form1->Memo1->Text = Form1->Memo1->Text + "Line Event \""+StrPas(Event)+"\" detected on port : \""+Port+"\" on device : \""+StrPas(DeviceSerial)+"\"\r\n";
}

//---------------------------------------------------------------------------
void fNewCall(PAnsiChar DeviceSerial,
			  PAnsiChar Caller,
			  PAnsiChar Callee,
			  PAnsiChar CallId,
			  char Port,
			  PAnsiChar Year,
			  PAnsiChar Month,
			  PAnsiChar Day,
			  PAnsiChar Hour,
			  PAnsiChar Minute)
{
  Form1->Memo1->Text = Form1->Memo1->Text +"Caller : "+StrPas(Caller)+", Callee : "+StrPas(Callee)+" Dt/Tm : "+StrPas(Year)+"-"+StrPas(Month)+"-"+StrPas(Day)+" "+StrPas(Hour)+":"+StrPas(Minute)+"\r\n";
}

//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  Form1->Memo1->Text = "";
  Form1->Label1->Caption = "";

  ceClass = CreateOleObject("CEHIDLibrary.CidEasyHIDLibrary");

  Byte dlgDvcArrival = ceClass.OlePropertyGet("oleDelegate_onDeviceArrival");
  Byte dlgDvcRemove = ceClass.OlePropertyGet("oleDelegate_onDeviceRemove");
  Byte dlgLineEvent = ceClass.OlePropertyGet("oleDelegate_onLineEvent");
  Byte dlgNewCall = ceClass.OlePropertyGet("oleDelegate_onNewCall_v2");

  ceClass.OleProcedure("ConstructModels",4660, 1);
  ceClass.OlePropertySet("enableCheckDigitControl",TRUE);
  ceClass.OlePropertySet("followLineEvents",TRUE);

  int devCount = ceClass.OlePropertyGet("numConnectedDevices");
  Label1->Caption = "Total " + IntToStr(devCount) + " of 4 device(s) attached";

  ceClass.OleProcedure("SetOleDelegate", dlgDvcArrival, (long)&fDeviceArrival);
  ceClass.OleProcedure("SetOleDelegate", dlgDvcRemove,  (long)&fDeviceRemove);
  ceClass.OleProcedure("SetOleDelegate", dlgLineEvent,  (long)&fLineEvent);
  ceClass.OleProcedure("SetOleDelegate", dlgNewCall,  (long)&fNewCall);
}
//---------------------------------------------------------------------------
